## g2clib 1.8.0

=== CMakeLists.txt ===
# This is the main CMake file for NCEPLIBS-g2c.
#
# Mark Potts, Kyle Gerheiser, Ed Hartnett, Eric Engle
cmake_minimum_required(VERSION 3.15)

# Read the VERSION file.
file(STRINGS "VERSION" pVersion)

# Set up the project.
project(g2c VERSION ${pVersion} LANGUAGES C)

# Provide install directories according to GNU standards.
include(GNUInstallDirs)

# Find CMake code we need.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/")

# Handle user options.
option(ENABLE_DOCS "Enable generation of doxygen-based documentation." OFF)
option(USE_PNG "Use PNG library"      ON)
option(USE_Jasper "Use Jasper library"   ON)
option(USE_OpenJPEG "Use OpenJPEG library" OFF)
option(USE_AEC "Use LibAEC library" OFF)
option(BUILD_SHARED_LIBS "Build shared libraries" ON)
option(BUILD_STATIC_LIBS "Build static libraries" ON)
option(FTP_TEST_FILES "Fetch and test with files on FTP site." OFF)
option(FTP_LARGE_TEST_FILES "Fetch and test with very large files on FTP site." OFF)
option(FTP_EXTRA_TEST_FILES "Test with files not yet available via FTP." OFF)
option(LOGGING "Turn on internal logging messages. Only useful to g2c developers." OFF)
option(PTHREADS "Turn on thread-safty with pthreads." OFF)
option(UTILS "Build and install some utility programs." ON)
option(BUILD_G2C "Build the new g2c API, experimental until 2.0.0 release." OFF)

# Developers can use this option to specify a local directory which
# holds the test files. They will be copied instead of fetching the
# files via FTP.
SET(TEST_FILE_DIR "." CACHE STRING "Check this directory for test files before using FTP.")
message(STATUS "Finding test data files in directory ${TEST_FILE_DIR}.")

# Set this to better handle files > 2 GB.
add_compile_definitions(_LARGEFILE64_SOURCE)

# Set pre-processor symbol if logging is desired.
if(LOGGING)
  add_definitions(-DLOGGING)
endif()

# Set pre-processor symbol if thread safety is desired.
if(PTHREADS)
  add_definitions(-DPTHREADS)
endif()

# The user must select either Jasper of OpenJPEG
if(USE_Jasper AND USE_OpenJPEG)
  message(FATAL_ERROR "Either Jasper or OpenJPEG should be used, not both.")
endif()

# Check the build type.
if(NOT CMAKE_BUILD_TYPE MATCHES "^(Debug|Release|RelWithDebInfo|MinSizeRel)$")
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE
      "Release"
      CACHE STRING "Choose the type of build." FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release"
                                               "MinSizeRel" "RelWithDebInfo")
endif()

# Find required packages to use PNG.
if(USE_PNG)
  find_package(ZLIB REQUIRED)
  find_package(PkgConfig REQUIRED)
  find_package(PNG REQUIRED)
else()
  message(STATUS "Will not build PNG support")
endif()

# Find Jasper if it is desired.
if(USE_Jasper)
  find_package(Jasper 2.0.25 REQUIRED)
  set(JASPER_MAX_MEM 268435456 CACHE STRING "Default size of Jasper memory buffer.")
  message(STATUS "\tWill build with Jasper memory buffer size = ${JASPER_MAX_MEM}")
else()
  message(STATUS "Will not build Jasper support")
endif()

# Find OpenJpeg if it is desired.
if(USE_OpenJPEG)
  find_package(OpenJPEG REQUIRED)
else()
  message(STATUS "Will not build OpenJPEG support")
endif()

# Turn on this pre-processor symbol to get JPEG code and testing.
if(USE_Jasper OR USE_OpenJPEG)
  add_definitions(-DJPEG)
endif()

# Find required packages to use AEC.
if(USE_AEC)
  find_package(libaec 1.0.6 REQUIRED)
  add_definitions(-DAEC)
else()
  message(STATUS "Will not build AEC support")
endif()

# Find libxml2.
if(BUILD_G2C)
  find_package(LibXml2 2.9.0 REQUIRED)
endif()

# Set the compiler flags.
if(CMAKE_C_COMPILER_ID MATCHES "^(Intel|IntelLLVM)$")
  set(CMAKE_C_FLAGS "-g -traceback ${CMAKE_C_FLAGS}")
  set(CMAKE_C_FLAGS_RELEASE "-O3")
  set(CMAKE_C_FLAGS_DEBUG "-O0")
elseif(CMAKE_C_COMPILER_ID MATCHES "^(GNU|Clang|AppleClang)$")
  set(CMAKE_C_FLAGS "-g ${CMAKE_C_FLAGS}")
  set(CMAKE_C_FLAGS_RELEASE "-O3")
  set(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb -Wall")
endif()

# Set this to better handle files > 2 GB.
add_compile_definitions(_LARGEFILE64_SOURCE)

set(lib_name ${PROJECT_NAME})

# Build the code in the source directory.
add_subdirectory(src)

# Build the code in the utils directory.
if(BUILD_G2C)
  if(UTILS)
    add_subdirectory(utils)
  endif()
endif()

# Determine whether or not to generate documentation.
if(ENABLE_DOCS)
  find_package(Doxygen REQUIRED)
endif()
add_subdirectory(docs)

# Run unit tests.
include(CTest)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

=== docs/CMakeLists.txt ===
# This is the CMake file for building the docs directory of NCEPLIBS-ip.
#
# Ed Hartnett 10/22/20

if(ENABLE_DOCS)

  # Create doxyfile.
  set(abs_top_srcdir "${CMAKE_SOURCE_DIR}")
  set(abs_top_builddir "${CMAKE_BINARY_DIR}")
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)

  # Build documentation with target all.
  add_custom_target(doc ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating API Documentation with Doxygen" VERBATIM)

endif(ENABLE_DOCS)

=== src/CMakeLists.txt ===
# This is the main CMake file for the src directory of NCEPLIBS-g2c.
#
# Ed Hartnett 12/29/22
# Eric Engle 1/10/23

set(lib_name ${PROJECT_NAME})

# Specify the source code files for the library.
set(src_files grib2_int.h cmplxpack.c compack.c
comunpack.c drstemplates.c g2_addfield.c g2_addgrid.c
g2_addlocal.c g2_create.c g2_free.c g2_getfld.c
g2_gribend.c g2_info.c g2_miss.c g2_unpack1.c
g2_unpack2.c g2_unpack3.c g2_unpack4.c g2_unpack5.c
g2_unpack6.c g2_unpack7.c gbits.c getdim.c
getpoly.c gridtemplates.c int_power.c misspack.c
mkieee.c pack_gp.c pdstemplates.c rdieee.c
reduce.c seekgb.c simpack.c simunpack.c specpack.c
specunpack.c util.c)

if(BUILD_G2C)
  set(src_files ${src_files}  g2cutil.c g2cxml.c g2cparams.c g2cfile.c
    g2cdegrib2.c g2cprod.c g2cinq.c g2cindex.c g2cio.c g2ccompare.c)
endif()

# Create object library.  The object library will be used to create
# static and shared libraries.
add_library(${lib_name}_objlib OBJECT ${src_files})
set_property(TARGET ${lib_name}_objlib PROPERTY C_STANDARD 11)
if(BUILD_SHARED_LIBS)
  set_property(TARGET ${lib_name}_objlib PROPERTY POSITION_INDEPENDENT_CODE 1)
endif()
add_library(${PROJECT_NAME}::${lib_name} ALIAS ${lib_name}_objlib)

# Create static object library from object library.
if(BUILD_STATIC_LIBS)
  add_library(${lib_name}_static STATIC $<TARGET_OBJECTS:${lib_name}_objlib>)
  set_target_properties(${lib_name}_static PROPERTIES OUTPUT_NAME ${lib_name})
  set_target_properties(${lib_name}_static PROPERTIES EXPORT_NAME ${lib_name})
  set_target_properties(${lib_name}_static PROPERTIES EXPORT_NAME ${lib_name}_static)
  list(APPEND LIB_TARGETS ${lib_name}_static)
endif()

# Create shared object library from object library.
if(BUILD_SHARED_LIBS)
  add_library(${lib_name}_shared SHARED $<TARGET_OBJECTS:${lib_name}_objlib>)
  set_target_properties(${lib_name}_shared PROPERTIES OUTPUT_NAME ${lib_name})
  set_target_properties(${lib_name}_shared PROPERTIES EXPORT_NAME ${lib_name})
  set_target_properties(${lib_name}_shared PROPERTIES SOVERSION 0)
  list(APPEND LIB_TARGETS ${lib_name}_shared)
endif()

# Link to libxml2.
if(BUILD_G2C)
  message(STATUS "libxml2 include directories ${LIBXML2_INCLUDE_DIR}")
  target_link_libraries(${lib_name}_objlib PRIVATE ${LIBXML2_LIBRARIES})
  target_include_directories(${lib_name}_objlib PRIVATE "${LIBXML2_INCLUDE_DIR}")
  if(BUILD_SHARED_LIBS)
    target_link_libraries(${lib_name}_shared PRIVATE ${LIBXML2_LIBRARIES})
    target_include_directories(${lib_name}_shared PRIVATE "${LIBXML2_INCLUDE_DIR}")
  endif()
  if(BUILD_STATIC_LIBS)
    target_link_libraries(${lib_name}_static PRIVATE ${LIBXML2_LIBRARIES})
    target_include_directories(${lib_name}_static PRIVATE "${LIBXML2_INCLUDE_DIR}")
  endif()
endif()

# Build with PNG.
if(PNG_FOUND)
  message(STATUS "PNG include directories ${PNG_INCLUDE_DIR}")
  message(STATUS "PNG libraries ${PNG_LIBRARIES}")
  target_sources(${lib_name}_objlib PRIVATE dec_png.c
                                     enc_png.c
                                     pngpack.c
                                     pngunpack.c)
  target_compile_definitions(${lib_name}_objlib PRIVATE USE_PNG)
  target_link_libraries(${lib_name}_objlib PRIVATE ${PNG_LIBRARIES})
  target_include_directories(${lib_name}_objlib PRIVATE "${PNG_INCLUDE_DIRS}")
  set(G2_PNG_ENABLED ON)
  if(BUILD_SHARED_LIBS)
    target_link_libraries(${lib_name}_shared PRIVATE ${PNG_LIBRARIES})
    target_include_directories(${lib_name}_shared PRIVATE "${PNG_INCLUDE_DIRS}")
  endif()
  if(BUILD_STATIC_LIBS)
    target_link_libraries(${lib_name}_static PRIVATE ${PNG_LIBRARIES})
    target_include_directories(${lib_name}_static PRIVATE "${PNG_INCLUDE_DIRS}")
  endif()
endif()

# Build with Jasper.
if(JASPER_FOUND)
  message(STATUS "JASPER include directories ${JASPER_INCLUDE_DIR}")
  message(STATUS "JASPER libraries ${JASPER_LIBRARIES} version ${JASPER_VERSION}")
  target_sources(${lib_name}_objlib PRIVATE dec_jpeg2000.c
                                     enc_jpeg2000.c
                                     jpcpack.c
                                     jpcunpack.c)
  target_compile_definitions(${lib_name}_objlib PRIVATE USE_JPEG2000)
  target_link_libraries(${lib_name}_objlib PRIVATE ${JASPER_LIBRARIES})
  target_include_directories(${lib_name}_objlib PRIVATE "${JASPER_INCLUDE_DIR}")
  set(G2_JPEG2000_ENABLED ON)
  if(JASPER_VERSION_STRING VERSION_GREATER_EQUAL "3")
    message(STATUS "      JASPER is version 3.0 or greater")
    add_definitions(-DJASPER3)
  endif()
  if(BUILD_SHARED_LIBS)
    target_link_libraries(${lib_name}_shared PRIVATE ${JASPER_LIBRARIES})
    target_include_directories(${lib_name}_shared PRIVATE "${JASPER_INCLUDE_DIRS}")
  endif()
  if(BUILD_STATIC_LIBS)
    target_link_libraries(${lib_name}_static PRIVATE ${JASPER_LIBRARIES})
    target_include_directories(${lib_name}_static PRIVATE "${JASPER_INCLUDE_DIRS}")
  endif()
endif()

# Build with OpenJPEG.
if(OPENJPEG_FOUND)
  message(STATUS "OpenJPEG include directories ${OpenJPEG_INCLUDE_DIRS}")
  message(STATUS "OpenJPEG libraries ${OpenJPEG_LIBRARIES}")
  target_sources(${lib_name}_objlib PRIVATE decenc_openjpeg.c
                                     jpcpack.c
                                     jpcunpack.c)
  target_compile_definitions(${lib_name}_objlib PRIVATE USE_OPENJPEG)
  target_link_libraries(${lib_name}_objlib PRIVATE ${OpenJPEG_LIBRARIES})
  target_include_directories(${lib_name}_objlib PRIVATE "${OpenJPEG_INCLUDE_DIRS}")
  set(G2_JPEG2000_ENABLED ON)
  if(BUILD_SHARED_LIBS)
    target_link_libraries(${lib_name}_shared PRIVATE ${OpenJPEG_LIBRARIES})
    target_include_directories(${lib_name}_shared PRIVATE "${OpenJPEG_INCLUDE_DIRS}")
  endif()
  if(BUILD_STATIC_LIBS)
    target_link_libraries(${lib_name}_static PRIVATE ${OpenJPEG_LIBRARIES})
    target_include_directories(${lib_name}_static PRIVATE "${OpenJPEG_INCLUDE_DIRS}")
  endif()
endif()

# Build with AEC.
if(LIBAEC_FOUND)
  set(AEC_LIBRARIES ${LIBAEC_LIBRARIES})
  set(AEC_INCLUDE_DIR ${LIBAEC_INCLUDE_DIRS})
  message(STATUS "AEC include directories ${AEC_INCLUDE_DIR}")
  message(STATUS "AEC libraries ${AEC_LIBRARIES}")
  target_sources(${lib_name}_objlib PRIVATE decenc_aec.c
                                            aecpack.c
                                            aecunpack.c)
  target_compile_definitions(${lib_name}_objlib PRIVATE USE_AEC)
  target_link_libraries(${lib_name}_objlib PRIVATE ${AEC_LIBRARIES})
  target_include_directories(${lib_name}_objlib PRIVATE "${AEC_INCLUDE_DIRS}")
  set(G2_AEC_ENABLED ON)
  if(BUILD_SHARED_LIBS)
    target_link_libraries(${lib_name}_shared PRIVATE ${AEC_LIBRARIES})
    target_include_directories(${lib_name}_shared PRIVATE "${AEC_INCLUDE_DIRS}")
  endif()
  if(BUILD_STATIC_LIBS)
    target_link_libraries(${lib_name}_static PRIVATE ${AEC_LIBRARIES})
    target_include_directories(${lib_name}_static PRIVATE "${AEC_INCLUDE_DIRS}")
  endif()
endif()

# Build with pthreads.
if(PTHREADS)
  target_link_libraries(${lib_name}_objlib PRIVATE pthread)
  if(BUILD_SHARED_LIBS)
    target_link_libraries(${lib_name}_shared PRIVATE pthread)
  endif()
  if(BUILD_STATIC_LIBS)
    target_link_libraries(${lib_name}_static PRIVATE pthread)
  endif()
endif()

# Create this header file, which has the contents of the VERSION file
# substituted in.
CONFIGURE_FILE("${CMAKE_CURRENT_SOURCE_DIR}/grib2.h.in" "${CMAKE_CURRENT_BINARY_DIR}/grib2.h"
  @ONLY)

target_include_directories(${lib_name}_objlib PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR};${CMAKE_CURRENT_SOURCE_DIR}>"
                                                     $<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include>)

target_link_libraries(${lib_name}_objlib INTERFACE m)
if(BUILD_SHARED_LIBS)
  target_link_libraries(${lib_name}_shared INTERFACE m)
endif()
if(BUILD_STATIC_LIBS)
  target_link_libraries(${lib_name}_static INTERFACE m)
endif()
if (WIN32)
  target_link_libraries(${lib_name}_objlib INTERFACE ws2_32)
endif()

# Install g2c library
install(
  TARGETS ${LIB_TARGETS}
  EXPORT ${PROJECT_NAME}Exports
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})

# Install generated grib2.h header
install(FILES ${CMAKE_BINARY_DIR}/src/grib2.h DESTINATION ${CMAKE_INSTALL_PREFIX}/include)

# Package config
include(CMakePackageConfigHelpers)
set(CONFIG_INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

export(EXPORT ${PROJECT_NAME}Exports
  NAMESPACE ${PROJECT_NAME}::
  FILE ${PROJECT_NAME}-targets.cmake)

# g2c-config.cmake
configure_package_config_file(
  ${CMAKE_SOURCE_DIR}/cmake/PackageConfig.cmake.in ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake
  INSTALL_DESTINATION ${CONFIG_INSTALL_DESTINATION})
install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake
  DESTINATION ${CONFIG_INSTALL_DESTINATION})

# g2c-config-version.cmake
write_basic_package_version_file(
  ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
  VERSION ${PROJECT_VERSION}
  COMPATIBILITY AnyNewerVersion)
install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake
  DESTINATION ${CONFIG_INSTALL_DESTINATION})

# g2c-targets.cmake and g2c-targets-<build-type>.cmake
install(EXPORT ${PROJECT_NAME}Exports
  NAMESPACE ${PROJECT_NAME}::
  FILE ${PROJECT_NAME}-targets.cmake
  DESTINATION ${CONFIG_INSTALL_DESTINATION})

# XML data files.
if(BUILD_G2C)
  set(XML_FILES Template.xml CodeFlag.xml)
  install(FILES ${XML_FILES}
    DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()

=== tests/CMakeLists.txt ===
# This is the cmake build file for the tests directory of the
# NCEPLIBS-g2c project.
#
# Ed Hartnett, 7/11/21
# Dusan Jovic
# Eric Engle 1/10/23

# Some test files are large and are kept on the NOAA EMC FTP
# site. This function is used to download such test data. It takes two
# arguments, the URL and the file to be downloaded.
function(PULL_DATA THE_URL THE_FILE)
  # If the TEST_FILE_DIR was specified, look for our test data files
  # there before FTPing them. Developers can keep all test files on
  # their machines, and save the time of downloading them every time.
  if(NOT ${TEST_FILE_DIR} STREQUAL ".")
    #message(STATUS "Checking for ${TEST_FILE_DIR}/${THE_FILE}.")
    if (EXISTS ${TEST_FILE_DIR}/${THE_FILE})
      message(STATUS "Copying file ${TEST_FILE_DIR}/${THE_FILE} to test data directory.")
      FILE(COPY ${TEST_FILE_DIR}/${THE_FILE}
        DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/data)
    endif()
  endif()
  if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/data/${THE_FILE}")
    message(STATUS "Downloading file ${CMAKE_CURRENT_BINARY_DIR}/data/${THE_FILE}.")
    file(DOWNLOAD
      ${THE_URL}/${THE_FILE}
      ${CMAKE_CURRENT_BINARY_DIR}/data/${THE_FILE}
      SHOW_PROGRESS
      STATUS status
      INACTIVITY_TIMEOUT 30
    )
    list(GET status 0 status_num)
    if(NOT status_num EQUAL 0 OR NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/data/${THE_FILE}")
      message(FATAL_ERROR "Could not download ${THE_FILE}")
    endif()
  endif()
endfunction()

# Some very small test files may be committed to the repo. Copies
# tests data files to the build directory.
set(REF_FILES "gdaswave.t00z.wcoast.0p16.f000.grib2.idx"
  "gdaswave.t00z.wcoast.0p16.f000.grib2"
  "ref_blend.t19z.core.f001.co.grib2.degrib2"
  "ref_blend.t19z.core.f001.co.grib2.grb2index"
  "ref_cmc_geavg.t12z.pgrb2a.0p50.f000.degrib2"
  "ref_cmc_geavg.t12z.pgrb2a.0p50.f000.grb2index"
  "ref_flxf2022111712.01.2022111712.grb2.degrib2"
  "ref_flxf2022111712.01.2022111712.grb2.grb2index"
  "ref_gdas.t12z.pgrb2.1p00.anl.degrib2"
  "ref_gdas.t12z.pgrb2.1p00.anl.grib2.degrib2"
  "ref_gdas.t12z.pgrb2.1p00.anl.grib2.grb2index"
  "ref_gdaswave.degrib2.txt"
  "ref_gdaswave.t00z.wcoast.0p16.f000.grb2index"
  "ref_GLOBAL.grib2.2022103000.0000.degrib2"
  "ref_GLOBAL.grib2.2022103000.0000.grb2index"
  "ref_hiresw.t00z.arw_5km.f00.hi.grib2.degrib2"
  "ref_hiresw.t00z.arw_5km.f00.hi.grib2.grb2index"
  "ref_naefs_ge10pt.t12z.pgrb2a.0p50_bcf003.degrib2"
  "ref_naefs_ge10pt.t12z.pgrb2a.0p50_bcf003.grb2index"
  "ref_rap.t00z.awp130pgrbf00.grib2.degrib2"
  "ref_rap.t00z.awp130pgrbf00.grib2.grb2index"
  "ref_seaice.t00z.grb.grib2.degrib2"
  "ref_seaice.t00z.grb.grib2.grb2index"
  "ref_sgx_nwps_CG3_20221117_1200.grib2.degrib2"
  "ref_sgx_nwps_CG3_20221117_1200.grib2.grb2index"
  "ref_WW3_Regional_US_West_Coast_20220718_0000.degrib2"
  "ref_WW3_Regional_US_West_Coast_20220718_0000.grb2index"
  "ref_WW3_Regional_US_West_Coast_20220718_0000.txt"
  "testgrib2.grb2"
  "ref_testgrib2.grb2.degrib2"
  "ref_gdaswave_2.grib1.idx"
  "ref_tst_jasper_warning.txt"
  )

# Copy extra files if needed.
if(FTP_EXTRA_TEST_FILES)
  if(FTP_LARGE_TEST_FILES)
    set(REF_FILES ${REF_FILES} "ref_fv3lam.t00z.prslev.f000.grib2.degrib2")
  endif()
endif()

foreach(THE_FILE IN LISTS REF_FILES) 
  FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/data/${THE_FILE}
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/data)
endforeach()

# These are the XML files from the WMO with GRIB2 code data.
if(BUILD_G2C)
  FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../src/CodeFlag.xml
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
  FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../src/Template.xml
    DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
endif()

# Build a C program test.
function(g2c_build_test name)
  add_executable(${name} ${name}.c util.c)
  target_link_libraries(${name} PUBLIC g2c::g2c)
  if(BUILD_G2C)
    target_link_libraries(${name} PRIVATE ${LIBXML2_LIBRARIES})
    target_include_directories(${name} PRIVATE "${LIBXML2_INCLUDE_DIR}")
  endif()
endfunction()

# Build a C program test.
function(g2c_build_test name)
  add_executable(${name} ${name}.c util.c)
  target_link_libraries(${name} PUBLIC g2c::g2c)
  target_link_libraries(${name} PRIVATE ${LIBXML2_LIBRARIES})
  target_include_directories(${name} PRIVATE "${LIBXML2_INCLUDE_DIR}")
endfunction()

# Run a C program test.
function(g2c_test name)
  g2c_build_test(${name})
  add_test(NAME ${name} COMMAND ${name})
endfunction()

# Run a test with pthreads, if configured.
function(g2c_ptest name)
  g2c_test(${name})
  if(PTHREADS)
    target_compile_definitions(${name} PRIVATE -DPTHREADS)    
    target_link_libraries(${name} PRIVATE pthread)
  endif()
endfunction()

# Run each shell test.
function(gu_test name)
  # Copy the test script.
  file(COPY "${CMAKE_SOURCE_DIR}/tests/${name}.sh"
    DESTINATION ${CMAKE_BINARY_DIR}/tests
    FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
  # Add the shell script as a test.
  add_test(NAME ${name}.sh COMMAND bash ${name}.sh)
  # Turn off memory checking in CI for this test.
  set_tests_properties(${name}.sh PROPERTIES LABELS noMemcheck)
endfunction()

# Does the user want to get extra test files from the FTP site, and
# run extra tests on them?
if(FTP_TEST_FILES)
  # Get the files from the FTP site.
  set(G2_FTP_URL "https://ftp.emc.ncep.noaa.gov/static_files/public/NCEPLIBS-g2")
  set(FTP_FILES "WW3_Regional_US_West_Coast_20220718_0000.grib2"
    "WW3_Regional_US_East_Coast_20220717_0600.grib2"
    "gdas.t12z.pgrb2.1p00.anl.grib2" "blend.t19z.core.f001.co.grib2"
    "cmc_geavg.t12z.pgrb2a.0p50.f000"
    "flxf2022111712.01.2022111712.grb2" 
    "GLOBAL.grib2.2022103000.0000" "hiresw.t00z.arw_5km.f00.hi.grib2"
    "naefs_ge10pt.t12z.pgrb2a.0p50_bcf003"
    "rap.t00z.awp130pgrbf00.grib2" "seaice.t00z.grb.grib2"
    "sgx_nwps_CG3_20221117_1200.grib2" "aqm.t12z.max_8hr_o3.227.grib2")
  foreach(THE_FILE IN LISTS FTP_FILES) 
    PULL_DATA(${G2_FTP_URL} ${THE_FILE})
  endforeach()

  if(FTP_EXTRA_TEST_FILES)
    if(FTP_LARGE_TEST_FILES)
      set(LARGE_FTP_FILES "fv3lam.t00z.prslev.f000.grib2")
      foreach(THE_FILE IN LISTS LARGE_FTP_FILES) 
        PULL_DATA(${G2_FTP_URL} ${THE_FILE})
      endforeach()
      add_definitions(-DLARGE_FTP_TESTS)
    endif()

    set(EXTRA_FTP_FILES "MRMS_MultiSensor_QPE_24H_Pass2_00.00_20230621-110000.grib2")
    foreach(THE_FILE IN LISTS EXTRA_FTP_FILES) 
      PULL_DATA(${G2_FTP_URL} ${THE_FILE})
    endforeach()
  endif()

  # Add this preprocessor definition so test files can conditionally
  # include testing based on FTP files.
  add_definitions(-DFTP_TEST_FILES)

  # Run this test only if FTP test files are used.
  if(BUILD_G2C)  
    g2c_ptest(tst_aqm)
  endif()
endif()

# Always run these tests.
g2c_test(tst_g2_create)
g2c_test(tst_g2_addgrid)
g2c_test(tst_g2_addfield)
g2c_test(tst_decode)
g2c_test(tst_gbits)
g2c_test(tst_gridtemplates)
g2c_test(tst_get_grid_template)
g2c_test(tst_pdstemplates)
g2c_test(tst_drstemplates)
g2c_test(tst_unpack)
g2c_test(tst_getdim)
g2c_test(tst_simpack)
g2c_test(tst_addfield_spec)
g2c_test(tst_spec)
g2c_test(tst_com)
g2c_test(tst_g2_addlocal)
g2c_test(tst_seekgb)

# Run these tests if the g2c API has been built.
if(BUILD_G2C)
  g2c_test(tst_index1)
  g2c_test(tst_xml)
  g2c_test(tst_error)
  g2c_test(tst_params)
  g2c_test(tst_params2)
  g2c_test(tst_params3)
  g2c_test(tst_io)
  g2c_test(tst_metacmp)
  g2c_test(tst_inq)
  g2c_test(tst_degrib2_int)
  g2c_test(tst_degrib2_fast)
  g2c_test(tst_degrib2)
  g2c_test(tst_degrib2_ftp_all)
  g2c_test(tst_index)
  g2c_ptest(tst_files)
  g2c_ptest(tst_g2_testfile)
endif()

# Run these tests only if libaec is linked.
if(USE_AEC)
  g2c_test(tst_aec)
endif()

# Run these tests only if libpng is linked.
if(USE_PNG)
  g2c_test(tst_png)
  g2c_test(tst_addfield2)
endif()

# Run these tests only if Jasper or OpenJPEG are linked.
if(USE_Jasper OR USE_OpenJPEG)
  g2c_test(tst_jpeg)
  g2c_test(tst_addfield3)
  g2c_test(tst_addfield4)
  g2c_build_test(tst_jasper_warning)
endif()

# Test for warnings from jasper.
if(USE_Jasper)
  gu_test(run_jasper_warning_test)
endif()

# Run these shell tests, which require Jasper.
if(BUILD_G2C)
  if(USE_Jasper)
    if(UTILS)
      gu_test(run_compare_tests)
      gu_test(run_degrib2_tests)
      gu_test(run_index_tests)
    endif()
  endif()
endif()

# Run these extra tests if you have the data files to do so.
if(FTP_EXTRA_TEST_FILES)
  g2c_test(tst_mrms)
endif()

=== debian/changelog ===
g2clib (1.8.0-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 05:30:29 +0000

g2clib (1.8.0-3build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:35:27 +0000

g2clib (1.8.0-3) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 16 Jan 2024 06:40:24 +0000

g2clib (1.8.0-2) experimental; urgency=medium

  * Build-dep on libaec-dev. Closes: #1059819

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 16 Dec 2023 09:20:44 +0000

g2clib (1.8.0-1) experimental; urgency=medium

  * New upstream release
  * Upstream now calls the shlib libg2c.so.0 ; drop 0d debian versioning
  * Drop transitional link now libgrib2c is history
  * Drop obsolete shlibs file
  * Standards-Version: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 28 Oct 2023 07:42:39 +0100

=== debian/control ===
Source: g2clib
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat  (= 13), 
 cmake,
 libpng-dev, 
 libaec-dev,
 zlib1g-dev, 
 pkg-config,
 doxygen,
 libopenjp2-7-dev 
Standards-Version: 4.6.2
Homepage: https://github.com/NOAA-EMC/NCEPLIBS-g2c
Vcs-Browser: https://salsa.debian.org:/science-team/g2clib.git
Vcs-Git: https://salsa.debian.org:/science-team/g2clib.git -b debian/latest

Package: libg2c0
Section: libs
Architecture: any
Breaks: libg2c0d
Replaces: libg2c0d
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: NCEP GRIB2 encoder/decoder library
 This is the libgrib2c library from NCEP for encoding and decoding 'GRIB2'
 data formats. 

Package: libg2c-dev
Section: libdevel
Architecture: any
Depends: libg2c0 ( = ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Recommends: pkg-config
Description: NCEP GRIB2 library - development files
 This is the libgrib2c library from NCEP for encoding and
 decoding 'GRIB2' data formats.
 .
 This package contains the static libraries and headers needed to build 
 applications against libgrib2.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# magic debhelper rule
%:
	dh $@ --buildsystem=cmake --builddirectory=debian/build

ifeq ($(DEB_HOST_ARCH_CPU),i386)
  export DEB_CFLAGS_MAINT_APPEND = -ffloat-store
endif

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) -I $(CURDIR)/debian/build/src 


export DH_VERBOSE=1

override_dh_auto_configure:
	dh_auto_configure  -- \
		-DCMAKE_C_CFLAGS="${CFLAGS}" \
		-DUSE_Jasper=OFF \
		-DUSE_OpenJPEG=On \
		-DUSE_AEC=On \
		-DENABLE_DOCS=Off


override_dh_auto_install:
	dh_auto_install
	# See #1011424
	rm -f ./debian/build/docs/man/man3/real.3

## g2clib 1.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 option(BUILD_STATIC_LIBS "Build static libraries" ON)
 option(FTP_TEST_FILES "Fetch and test with files on FTP site." OFF)
 option(FTP_LARGE_TEST_FILES "Fetch and test with very large files on FTP site." OFF)
-option(FTP_EXTRA_TEST_FILES "Test with files not yet available via FTP." OFF)
+option(FTP_EXTRA_TEST_FILES "Test with more large files fetched via FTP." OFF)
 option(LOGGING "Turn on internal logging messages. Only useful to g2c developers." OFF)
 option(PTHREADS "Turn on thread-safty with pthreads." OFF)
 option(UTILS "Build and install some utility programs." ON)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -175,13 +175,16 @@
 target_include_directories(${lib_name}_objlib PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR};${CMAKE_CURRENT_SOURCE_DIR}>"
                                                      $<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include>)
 
-target_link_libraries(${lib_name}_objlib INTERFACE m)
-if(BUILD_SHARED_LIBS)
-  target_link_libraries(${lib_name}_shared INTERFACE m)
-endif()
-if(BUILD_STATIC_LIBS)
-  target_link_libraries(${lib_name}_static INTERFACE m)
-endif()
+if (NOT WIN32)
+  target_link_libraries(${lib_name}_objlib INTERFACE m)
+  if(BUILD_SHARED_LIBS)
+    target_link_libraries(${lib_name}_shared INTERFACE m)
+  endif()
+  if(BUILD_STATIC_LIBS)
+    target_link_libraries(${lib_name}_static INTERFACE m)
+  endif()
+endif()
+
 if (WIN32)
   target_link_libraries(${lib_name}_objlib INTERFACE ws2_32)
 endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,8 @@
 # Ed Hartnett, 7/11/21
 # Dusan Jovic
 # Eric Engle 1/10/23
+
+message(STATUS "Building test directory...")
 
 # Some test files are large and are kept on the NOAA EMC FTP
 # site. This function is used to download such test data. It takes two
@@ -13,7 +15,7 @@
   # there before FTPing them. Developers can keep all test files on
   # their machines, and save the time of downloading them every time.
   if(NOT ${TEST_FILE_DIR} STREQUAL ".")
-    #message(STATUS "Checking for ${TEST_FILE_DIR}/${THE_FILE}.")
+    message(STATUS "Checking for ${TEST_FILE_DIR}/${THE_FILE}.")
     if (EXISTS ${TEST_FILE_DIR}/${THE_FILE})
       message(STATUS "Copying file ${TEST_FILE_DIR}/${THE_FILE} to test data directory.")
       FILE(COPY ${TEST_FILE_DIR}/${THE_FILE}
@@ -49,7 +51,7 @@
   "ref_gdas.t12z.pgrb2.1p00.anl.degrib2"
   "ref_gdas.t12z.pgrb2.1p00.anl.grib2.degrib2"
   "ref_gdas.t12z.pgrb2.1p00.anl.grib2.grb2index"
-  "ref_gdaswave.degrib2.txt"
+  "ref_gdaswave.t00z.wcoast.0p16.f000.grib2.degrib2"
   "ref_gdaswave.t00z.wcoast.0p16.f000.grb2index"
   "ref_GLOBAL.grib2.2022103000.0000.degrib2"
   "ref_GLOBAL.grib2.2022103000.0000.grb2index"
@@ -72,11 +74,9 @@
   "ref_tst_jasper_warning.txt"
   )
 
-# Copy extra files if needed.
-if(FTP_EXTRA_TEST_FILES)
-  if(FTP_LARGE_TEST_FILES)
-    set(REF_FILES ${REF_FILES} "ref_fv3lam.t00z.prslev.f000.grib2.degrib2")
-  endif()
+# Copy large files if needed.
+if(FTP_LARGE_TEST_FILES)
+  set(REF_FILES ${REF_FILES} "ref_fv3lam.t00z.prslev.f000.grib2.degrib2")
 endif()
 
 foreach(THE_FILE IN LISTS REF_FILES) 
@@ -94,7 +94,7 @@
 
 # Build a C program test.
 function(g2c_build_test name)
-  add_executable(${name} ${name}.c util.c)
+  add_executable(${name} ${name}.c g2c_test_util.c)
   target_link_libraries(${name} PUBLIC g2c::g2c)
   if(BUILD_G2C)
     target_link_libraries(${name} PRIVATE ${LIBXML2_LIBRARIES})
@@ -104,7 +104,7 @@
 
 # Build a C program test.
 function(g2c_build_test name)
-  add_executable(${name} ${name}.c util.c)
+  add_executable(${name} ${name}.c g2c_test_util.c)
   target_link_libraries(${name} PUBLIC g2c::g2c)
   target_link_libraries(${name} PRIVATE ${LIBXML2_LIBRARIES})
   target_include_directories(${name} PRIVATE "${LIBXML2_INCLUDE_DIR}")
@@ -155,16 +155,17 @@
     PULL_DATA(${G2_FTP_URL} ${THE_FILE})
   endforeach()
 
+  if(FTP_LARGE_TEST_FILES)
+    set(LARGE_FTP_FILES "fv3lam.t00z.prslev.f000.grib2")
+    foreach(THE_FILE IN LISTS LARGE_FTP_FILES) 
+      PULL_DATA(${G2_FTP_URL} ${THE_FILE})
+    endforeach()
+    add_definitions(-DLARGE_FTP_TESTS)
+  endif()
+
   if(FTP_EXTRA_TEST_FILES)
-    if(FTP_LARGE_TEST_FILES)
-      set(LARGE_FTP_FILES "fv3lam.t00z.prslev.f000.grib2")
-      foreach(THE_FILE IN LISTS LARGE_FTP_FILES) 
-        PULL_DATA(${G2_FTP_URL} ${THE_FILE})
-      endforeach()
-      add_definitions(-DLARGE_FTP_TESTS)
-    endif()
-
-    set(EXTRA_FTP_FILES "MRMS_MultiSensor_QPE_24H_Pass2_00.00_20230621-110000.grib2")
+    set(EXTRA_FTP_FILES MRMS_MultiSensor_QPE_24H_Pass2_00.00_20230621-110000.grib2
+      GFSPRS.GrbF06 rrfs.t18z.prslev.f000.grib2)
     foreach(THE_FILE IN LISTS EXTRA_FTP_FILES) 
       PULL_DATA(${G2_FTP_URL} ${THE_FILE})
     endforeach()
@@ -250,6 +251,12 @@
       gu_test(run_compare_tests)
       gu_test(run_degrib2_tests)
       gu_test(run_index_tests)
+      if(FTP_LARGE_TEST_FILES)
+	gu_test(run_large_index_tests)
+      endif()
+      if(FTP_EXTRA_TEST_FILES)
+	gu_test(run_extra_index_tests)
+      endif()
     endif()
   endif()
 endif()

=== debian/changelog ===
g2clib (1.9.0-1) unstable; urgency=medium

  * New upstream release
  * Depend/recommend pkgconf instead of pkg-config

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 24 Mar 2024 07:44:03 +0000

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: g2clib
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat  (= 13), 
  cmake,
  libpng-dev, 
  libaec-dev,
  zlib1g-dev, 
- pkg-config,
+ pkgconf,
  doxygen,
  libopenjp2-7-dev 
 Standards-Version: 4.6.2
@@ -32,7 +31,7 @@
 Architecture: any
 Depends: libg2c0 ( = ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
-Recommends: pkg-config
+Recommends: pkgconf
 Description: NCEP GRIB2 library - development files
  This is the libgrib2c library from NCEP for encoding and
  decoding 'GRIB2' data formats.

## g2clib 2.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 option(LOGGING "Turn on internal logging messages. Only useful to g2c developers." OFF)
 option(PTHREADS "Turn on thread-safty with pthreads." OFF)
 option(UTILS "Build and install some utility programs." ON)
-option(BUILD_G2C "Build the new g2c API, experimental until 2.0.0 release." OFF)
+option(BUILD_G2C "Build the g2c file-based API." ON)
 
 # Developers can use this option to specify a local directory which
 # holds the test files. They will be copied instead of fetching the
@@ -103,11 +103,6 @@
   message(STATUS "Will not build AEC support")
 endif()
 
-# Find libxml2.
-if(BUILD_G2C)
-  find_package(LibXml2 2.9.0 REQUIRED)
-endif()
-
 # Set the compiler flags.
 if(CMAKE_C_COMPILER_ID MATCHES "^(Intel|IntelLLVM)$")
   set(CMAKE_C_FLAGS "-g -traceback ${CMAKE_C_FLAGS}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -18,7 +18,7 @@
 specunpack.c util.c)
 
 if(BUILD_G2C)
-  set(src_files ${src_files}  g2cutil.c g2cxml.c g2cparams.c g2cfile.c
+  set(src_files ${src_files}  g2cutil.c g2ccsv.c g2cparams.c g2cfile.c
     g2cdegrib2.c g2cprod.c g2cinq.c g2cindex.c g2cio.c g2ccompare.c)
 endif()
 
@@ -49,27 +49,11 @@
   list(APPEND LIB_TARGETS ${lib_name}_shared)
 endif()
 
-# Link to libxml2.
-if(BUILD_G2C)
-  message(STATUS "libxml2 include directories ${LIBXML2_INCLUDE_DIR}")
-  target_link_libraries(${lib_name}_objlib PRIVATE ${LIBXML2_LIBRARIES})
-  target_include_directories(${lib_name}_objlib PRIVATE "${LIBXML2_INCLUDE_DIR}")
-  if(BUILD_SHARED_LIBS)
-    target_link_libraries(${lib_name}_shared PRIVATE ${LIBXML2_LIBRARIES})
-    target_include_directories(${lib_name}_shared PRIVATE "${LIBXML2_INCLUDE_DIR}")
-  endif()
-  if(BUILD_STATIC_LIBS)
-    target_link_libraries(${lib_name}_static PRIVATE ${LIBXML2_LIBRARIES})
-    target_include_directories(${lib_name}_static PRIVATE "${LIBXML2_INCLUDE_DIR}")
-  endif()
-endif()
-
 # Build with PNG.
 if(PNG_FOUND)
   message(STATUS "PNG include directories ${PNG_INCLUDE_DIR}")
   message(STATUS "PNG libraries ${PNG_LIBRARIES}")
-  target_sources(${lib_name}_objlib PRIVATE dec_png.c
-                                     enc_png.c
+  target_sources(${lib_name}_objlib PRIVATE decenc_png.c
                                      pngpack.c
                                      pngunpack.c)
   target_compile_definitions(${lib_name}_objlib PRIVATE USE_PNG)
@@ -90,8 +74,7 @@
 if(JASPER_FOUND)
   message(STATUS "JASPER include directories ${JASPER_INCLUDE_DIR}")
   message(STATUS "JASPER libraries ${JASPER_LIBRARIES} version ${JASPER_VERSION}")
-  target_sources(${lib_name}_objlib PRIVATE dec_jpeg2000.c
-                                     enc_jpeg2000.c
+  target_sources(${lib_name}_objlib PRIVATE decenc_jpeg2000.c
                                      jpcpack.c
                                      jpcunpack.c)
   target_compile_definitions(${lib_name}_objlib PRIVATE USE_JPEG2000)
@@ -144,15 +127,15 @@
                                             aecunpack.c)
   target_compile_definitions(${lib_name}_objlib PRIVATE USE_AEC)
   target_link_libraries(${lib_name}_objlib PRIVATE ${AEC_LIBRARIES})
-  target_include_directories(${lib_name}_objlib PRIVATE "${AEC_INCLUDE_DIRS}")
+  target_include_directories(${lib_name}_objlib PRIVATE "${AEC_INCLUDE_DIR}")
   set(G2_AEC_ENABLED ON)
   if(BUILD_SHARED_LIBS)
     target_link_libraries(${lib_name}_shared PRIVATE ${AEC_LIBRARIES})
-    target_include_directories(${lib_name}_shared PRIVATE "${AEC_INCLUDE_DIRS}")
+    target_include_directories(${lib_name}_shared PRIVATE "${AEC_INCLUDE_DIR}")
   endif()
   if(BUILD_STATIC_LIBS)
     target_link_libraries(${lib_name}_static PRIVATE ${AEC_LIBRARIES})
-    target_include_directories(${lib_name}_static PRIVATE "${AEC_INCLUDE_DIRS}")
+    target_include_directories(${lib_name}_static PRIVATE "${AEC_INCLUDE_DIR}")
   endif()
 endif()
 
@@ -174,6 +157,14 @@
 
 target_include_directories(${lib_name}_objlib PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR};${CMAKE_CURRENT_SOURCE_DIR}>"
                                                      $<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include>)
+if(BUILD_SHARED_LIBS)
+  target_include_directories(${lib_name}_shared PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR};${CMAKE_CURRENT_SOURCE_DIR}>"
+                                                       $<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include>)
+endif()
+if(BUILD_STATIC_LIBS)
+  target_include_directories(${lib_name}_static PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR};${CMAKE_CURRENT_SOURCE_DIR}>"
+                                                       $<INSTALL_INTERFACE:${CMAKE_INSTALL_PREFIX}/include>)
+endif()
 
 if (NOT WIN32)
   target_link_libraries(${lib_name}_objlib INTERFACE m)
@@ -210,7 +201,7 @@
 
 # g2c-config.cmake
 configure_package_config_file(
-  ${CMAKE_SOURCE_DIR}/cmake/PackageConfig.cmake.in ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake
+  ${PROJECT_SOURCE_DIR}/cmake/PackageConfig.cmake.in ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake
   INSTALL_DESTINATION ${CONFIG_INSTALL_DESTINATION})
 install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}-config.cmake
   DESTINATION ${CONFIG_INSTALL_DESTINATION})
@@ -229,9 +220,9 @@
   FILE ${PROJECT_NAME}-targets.cmake
   DESTINATION ${CONFIG_INSTALL_DESTINATION})
 
-# XML data files.
+# CSV data files.
 if(BUILD_G2C)
-  set(XML_FILES Template.xml CodeFlag.xml)
-  install(FILES ${XML_FILES}
-    DESTINATION ${CMAKE_INSTALL_LIBDIR})
-endif()
+  set(CSV_FILES Template.txt CodeFlag.txt)
+  install(FILES ${CSV_FILES}
+    DESTINATION ${CMAKE_INSTALL_PREFIX}/share/g2c/)
+endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -79,16 +79,16 @@
   set(REF_FILES ${REF_FILES} "ref_fv3lam.t00z.prslev.f000.grib2.degrib2")
 endif()
 
-foreach(THE_FILE IN LISTS REF_FILES) 
+foreach(THE_FILE IN LISTS REF_FILES)
   FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/data/${THE_FILE}
     DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/data)
 endforeach()
 
-# These are the XML files from the WMO with GRIB2 code data.
+# These are the CSV files from the WMO with GRIB2 code data.
 if(BUILD_G2C)
-  FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../src/CodeFlag.xml
+  FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../src/CodeFlag.txt
     DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
-  FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../src/Template.xml
+  FILE(COPY ${CMAKE_CURRENT_SOURCE_DIR}/../src/Template.txt
     DESTINATION ${CMAKE_CURRENT_BINARY_DIR}/)
 endif()
 
@@ -96,18 +96,12 @@
 function(g2c_build_test name)
   add_executable(${name} ${name}.c g2c_test_util.c)
   target_link_libraries(${name} PUBLIC g2c::g2c)
-  if(BUILD_G2C)
-    target_link_libraries(${name} PRIVATE ${LIBXML2_LIBRARIES})
-    target_include_directories(${name} PRIVATE "${LIBXML2_INCLUDE_DIR}")
-  endif()
 endfunction()
 
 # Build a C program test.
 function(g2c_build_test name)
   add_executable(${name} ${name}.c g2c_test_util.c)
   target_link_libraries(${name} PUBLIC g2c::g2c)
-  target_link_libraries(${name} PRIVATE ${LIBXML2_LIBRARIES})
-  target_include_directories(${name} PRIVATE "${LIBXML2_INCLUDE_DIR}")
 endfunction()
 
 # Run a C program test.
@@ -120,7 +114,7 @@
 function(g2c_ptest name)
   g2c_test(${name})
   if(PTHREADS)
-    target_compile_definitions(${name} PRIVATE -DPTHREADS)    
+    target_compile_definitions(${name} PRIVATE -DPTHREADS)
     target_link_libraries(${name} PRIVATE pthread)
   endif()
 endfunction()
@@ -146,18 +140,18 @@
     "WW3_Regional_US_East_Coast_20220717_0600.grib2"
     "gdas.t12z.pgrb2.1p00.anl.grib2" "blend.t19z.core.f001.co.grib2"
     "cmc_geavg.t12z.pgrb2a.0p50.f000"
-    "flxf2022111712.01.2022111712.grb2" 
+    "flxf2022111712.01.2022111712.grb2"
     "GLOBAL.grib2.2022103000.0000" "hiresw.t00z.arw_5km.f00.hi.grib2"
     "naefs_ge10pt.t12z.pgrb2a.0p50_bcf003"
     "rap.t00z.awp130pgrbf00.grib2" "seaice.t00z.grb.grib2"
     "sgx_nwps_CG3_20221117_1200.grib2" "aqm.t12z.max_8hr_o3.227.grib2")
-  foreach(THE_FILE IN LISTS FTP_FILES) 
+  foreach(THE_FILE IN LISTS FTP_FILES)
     PULL_DATA(${G2_FTP_URL} ${THE_FILE})
   endforeach()
 
   if(FTP_LARGE_TEST_FILES)
     set(LARGE_FTP_FILES "fv3lam.t00z.prslev.f000.grib2")
-    foreach(THE_FILE IN LISTS LARGE_FTP_FILES) 
+    foreach(THE_FILE IN LISTS LARGE_FTP_FILES)
       PULL_DATA(${G2_FTP_URL} ${THE_FILE})
     endforeach()
     add_definitions(-DLARGE_FTP_TESTS)
@@ -166,7 +160,7 @@
   if(FTP_EXTRA_TEST_FILES)
     set(EXTRA_FTP_FILES MRMS_MultiSensor_QPE_24H_Pass2_00.00_20230621-110000.grib2
       GFSPRS.GrbF06 rrfs.t18z.prslev.f000.grib2)
-    foreach(THE_FILE IN LISTS EXTRA_FTP_FILES) 
+    foreach(THE_FILE IN LISTS EXTRA_FTP_FILES)
       PULL_DATA(${G2_FTP_URL} ${THE_FILE})
     endforeach()
   endif()
@@ -176,7 +170,7 @@
   add_definitions(-DFTP_TEST_FILES)
 
   # Run this test only if FTP test files are used.
-  if(BUILD_G2C)  
+  if(BUILD_G2C)
     g2c_ptest(tst_aqm)
   endif()
 endif()
@@ -203,7 +197,7 @@
 # Run these tests if the g2c API has been built.
 if(BUILD_G2C)
   g2c_test(tst_index1)
-  g2c_test(tst_xml)
+  g2c_test(tst_csv)
   g2c_test(tst_error)
   g2c_test(tst_params)
   g2c_test(tst_params2)
@@ -251,6 +245,9 @@
       gu_test(run_compare_tests)
       gu_test(run_degrib2_tests)
       gu_test(run_index_tests)
+      if(FTP_TEST_FILES)
+	gu_test(run_ftp_index_tests)
+      endif()
       if(FTP_LARGE_TEST_FILES)
 	gu_test(run_large_index_tests)
       endif()
@@ -262,11 +259,13 @@
 endif()
 
 # Run these extra tests if you have the data files to do so.
-if(FTP_EXTRA_TEST_FILES)
-  g2c_test(tst_mrms)
-endif()
-
-
-
-
-
+if (BUILD_G2C)
+  if(FTP_EXTRA_TEST_FILES)
+    g2c_test(tst_mrms)
+  endif()
+endif()
+
+
+
+
+

=== debian/changelog ===
g2clib (2.0.0-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Dec 2024 18:17:04 +0000

g2clib (2.0.0-1) experimental; urgency=medium

  * New upstream release
  * Add new g2clib-utils package for tools
  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * Update pkgconf file to ensure we build with libaec.
  * Disable tests for this release
  * Include /usr/share/g2c/* data files in lib pkg
  * Include docs

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 25 Apr 2024 16:03:10 +0100

=== debian/control ===
Source: g2clib
Section: utils
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat  (= 13), 
 cmake,
 libpng-dev, 
 libaec-dev,
 zlib1g-dev, 
 pkgconf,
 doxygen,
 libopenjp2-7-dev 
Standards-Version: 4.7.0
Homepage: https://github.com/NOAA-EMC/NCEPLIBS-g2c
Vcs-Browser: https://salsa.debian.org/science-team/g2clib.git
Vcs-Git: https://salsa.debian.org/science-team/g2clib.git -b debian/latest

Package: libg2c0
Section: libs
Architecture: any
Breaks: libg2c0d
Replaces: libg2c0d
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: NCEP GRIB2 encoder/decoder library
 This is the libg2c library from NCEP for encoding and decoding 'GRIB2'
 data formats. 

Package: libg2c-utils
Architecture: any
Depends:  libg2c0 ( = ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: NCEP GRIB2 library - development files
 This is the libg2c library from NCEP for encoding and
 decoding 'GRIB2' data formats.
 .
 This package  contains the g2c_compare, g2c_degrib2 and g2c_index utilites.

Package: libg2c-dev
Section: libdevel
Architecture: any
Depends: libg2c0 ( = ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Recommends: pkgconf
Description: NCEP GRIB2 library - development files
 This is the libg2c library from NCEP for encoding and
 decoding 'GRIB2' data formats.
 .
 This package contains the static libraries and headers needed to build 
 applications against libg2c.

=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,10 @@
 		-DUSE_Jasper=OFF \
 		-DUSE_OpenJPEG=On \
 		-DUSE_AEC=On \
-		-DENABLE_DOCS=Off
+		-DENABLE_DOCS=On
+
+override_dh_auto_test:
+	@echo Disable tests for this release
 
 
 override_dh_auto_install:

## g2clib 2.1.0

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -72,6 +72,7 @@
   "ref_testgrib2.grb2.degrib2"
   "ref_gdaswave_2.grib1.idx"
   "ref_tst_jasper_warning.txt"
+  "ref_large_png.grib2"
   )
 
 # Copy large files if needed.
@@ -223,6 +224,7 @@
 if(USE_PNG)
   g2c_test(tst_png)
   g2c_test(tst_addfield2)
+  g2c_test(tst_large_png)
 endif()
 
 # Run these tests only if Jasper or OpenJPEG are linked.
@@ -243,8 +245,6 @@
   if(USE_Jasper)
     if(UTILS)
       gu_test(run_compare_tests)
-      gu_test(run_degrib2_tests)
-      gu_test(run_index_tests)
       if(FTP_TEST_FILES)
 	gu_test(run_ftp_index_tests)
       endif()

=== debian/changelog ===
g2clib (2.1.0-1) unstable; urgency=medium

  * New upstream release
  * Drop M-A: same for g2clib-utils

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Jan 2025 07:59:50 +0000

g2clib (2.0.0-3) unstable; urgency=medium

  * Don't ship MIN.3 manpage. Closes: #1091674
  * Pass CC and PKG_CONFIG to enable cross-compiling. Closes: #997942
  * Enable tests but ignore failures this release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 07 Jan 2025 12:19:58 +0000

=== debian/control ===
--- 
+++ 
@@ -30,7 +30,6 @@
 Package: libg2c-utils
 Architecture: any
 Depends:  libg2c0 ( = ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
-Multi-Arch: same
 Description: NCEP GRIB2 library - development files
  This is the libg2c library from NCEP for encoding and
  decoding 'GRIB2' data formats.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildtools.mk

# magic debhelper rule
%:
	dh $@ --buildsystem=cmake --builddirectory=debian/build

ifeq ($(DEB_HOST_ARCH_CPU),i386)
  export DEB_CFLAGS_MAINT_APPEND = -ffloat-store
endif

DESTDIR:=$(CURDIR)/debian/tmp/
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) -I $(CURDIR)/debian/build/src 


export DH_VERBOSE=1

override_dh_auto_configure:
	CC=$(CC) PKG_CONFIG=$(PKG_CONFIG) dh_auto_configure  -- \
		-DCMAKE_C_CFLAGS="${CFLAGS}" \
		-DUSE_Jasper=OFF \
		-DUSE_OpenJPEG=On \
		-DUSE_AEC=On \
		-DENABLE_DOCS=On

override_dh_auto_test:
	dh_auto_test || echo "Ignore failures"


override_dh_auto_install:
	dh_auto_install
	# See #1011424
	rm -f ./debian/build/docs/man/man3/real.3
	# See #1091674
	rm -r debian/build/docs/man/man3/MIN.3
